#!/usr/bin/python3
# -*- coding: utf-8 -*-
#from __future__ import print_function
_FonctionDuProgramme="differentes fonctions utilisables"
#print(_FonctionDuProgramme)
_Version="1.0.1"
"""

1.0.1 md5 : renvoir time .time() si erreur
"""
#print("version:"+_Version)
import re
import os
##################### debug
import sys

_debug_Titres=True # _debug_Titres=False
_debug_all=True # 
_debug_all=False

if _debug_all==True:
	_debug_Titres=True

if _debug_Titres==True:
	_FichierLog='/tmp/'+re.sub('.*/','',sys.argv[0])+'.log'
	_Log=open(_FichierLog,'w')

def Tprint(*args, **kwargs):
	if _debug_Titres==True:
		print(*args, **kwargs)					
		print(*args,file=_Log)
def Dprint(ligne):
	if _debug_all==True:
		print(ligne)
		print('--------------------------')
# # # # # # # # # # # # # # # # # # # debug
# ajout de doc + Tprint sed -e 's/^\(.*\)\(def\ \)\(.*\)$/\1\2\3\n\1\t"""-*\3"""\n\1\tTprint("\3")/' -i aa.py
class br_CDICO(dict):
	  def __missing__(self, key):
		  return ""

class CMachin(object):
	""" CLASSE CMachin(object) """
	def __init__(self,_rep=''):
		pass#self._repertoire=_rep
		
'''
print ( os.path.split('/tmp/bb.jpg') )
('/tmp', 'bb.jpg')
print ( os.path.splitext('/tmp/bb.jpg') )
('/tmp/bb', '.jpg')


print ( os.path.split('/tmp/bb/') )
('/tmp/bb', '')
print ( os.path.splitext('/tmp/bb/') )
('/tmp/bb/', '')



print ( o.split('/tmp/bb') )
('/tmp', 'bb')
print ( os.path.splitext('/tmp/bb') )
('/tmp/bb', '')

'''		
DicoFonctions=br_CDICO()

def	TableauToString(tablo,sep=""):
	''' str//None TableauToString(tablo,sep="") : tableau de string devient une string '''
	texte=""
	for t in tablo:
		if isinstance(t,str):
			texte+=t+sep
		else:
			return None	
	return texte	
DicoFonctions["TableauToString"]=TableauToString.__doc__


#1.0.5 def Md5(fname):	''' str Md5('nom fich') '''
def Md5(fname,Impossible="time"):	
	''' str//time()//\"\" Md5('nom fich' , Impossible="time" ) '''
	import hashlib
	hash_md5 = hashlib.md5()
	try:
		with open(fname, "rb") as f:
			for chunk in iter(lambda: f.read(4096), b""):
				hash_md5.update(chunk)
		return hash_md5.hexdigest()
	except:
		if Impossible=="time":
			from time import time
			return str(time())
		else:
			return ""
DicoFonctions["Md5"]=Md5.__doc__




def HexsInt(hexa,N=1):
	""" transforme des blocs d'hexadecimaux de longueur N en entiers """
	res=[]
	for i in range(0,len(hexa),N):
		hexaN=hexa[i:i+N]
		"""
		nb=0		
		for j in range(N):
			nb=nb*16+HexInt(hexaN[j])
		"""	
		nb=HexInt(hexaN)
		res+=[nb]
	return res	
DicoFonctions["HexInt"]=HexsInt.__doc__	

def HexInt(hexa):
	""" transforme un hexadecimal de longueur N en entier """
	res=""
	try:
		N=len(hexa)
	except:
		hexa=[hexa]
		N=len(hexa)
	for i in range(N):
		if N==1:
			if ord(hexa[i])<48+10:
				nb=ord(hexa[i])-48
			else:
				nb=ord(hexa[i])-87
			res=nb
		else:		
			nb=0		
			for j in range(N):
				nb=nb*16+HexInt(hexa[j])
			res=nb
	return res		
DicoFonctions["HexInt"]=HexInt.__doc__		
	
	
global main

if __name__ == "__main__":
	Dprint("Le programme lancé est "+sys.argv[0])
	print(HexsInt('1ab',1))
	print(_FonctionDuProgramme)
	print("version:"+_Version)

	
	print('import CFonctions')
	for a in DicoFonctions:
		print('from CFonctions import '+a)
		print("  "+DicoFonctions[a])
	
	
	
	sys.exit()


