#!/usr/bin/python3
# -*- coding: utf-8 -*-
#from __future__ import print_function
_FonctionDuProgramme="Creer des thumbnails de tous les pdf en gardant la hierarchie des dossiers"
#print(_FonctionDuProgramme)
_Version="1.0"
#print("version:"+_Version)
import re
import os
##################### debug
import sys

_debug_Titres=True # _debug_Titres=False
_debug_all=True # 
_debug_all=False

if _debug_all==True:
	_debug_Titres=True

if _debug_Titres==True:
	_FichierLog='/tmp/'+sys.argv[0]+'.log'
	_Log=open(_FichierLog,'w')

def Tprint(*args, **kwargs):
	if _debug_Titres==True:
		print(*args, **kwargs)					
		print(*args,file=_Log)
def Dprint(ligne):
	if _debug_all==True:
		print(ligne)
		print('--------------------------')
# # # # # # # # # # # # # # # # # # # debug

import CMatrixMatrices
from CMatrixMatrices import *

class br_CDICO(dict):
	  def __missing__(self, key):
		  return ""

class CPoint(object):
	""" CLASSE CPoint(object) """
	def __init__(self,x=0,y=0,z=0):
		self._x,self._y,self._z=x,y,z
		self._v=self.vecteur()
		pass#self._repertoire=_rep
	def vecteur(self):
		self._v=Vecteur3(self._x,self._y,self._z)
		return self._v


class CArete(object):
	""" CLASSE CArete(object) """
	def __init__(self,i=CPoint(),j=CPoint()):
		self._points=[i,j]
		self._vecteur=self.vecteur()		
		pass#self._repertoire=_rep
		
	def vecteur(self):
		p1,p2=self._points
		self._vecteur=p2._v-p1._v
		self._v=self._vecteur		
		return self._vecteur

class CSurface(object):
	""" CLASSE CSurface(object) """
	def __init__(self,i=CPoint(),j=CPoint(),k=CPoint()):
		self._points=[i,j,k]
		
		pass#self._repertoire=_rep
		
	def vecteur(self):
		p1,p2=self._points
		self._vecteur=p2._v-p1._v
		self._v=self._vecteur		
		return self._vecteur

				
'''
print ( os.path.split('/tmp/bb.jpg') )
('/tmp', 'bb.jpg')
print ( os.path.splitext('/tmp/bb.jpg') )
('/tmp/bb', '.jpg')


print ( os.path.split('/tmp/bb/') )
('/tmp/bb', '')
print ( os.path.splitext('/tmp/bb/') )
('/tmp/bb/', '')



print ( o.split('/tmp/bb') )
('/tmp', 'bb')
print ( os.path.splitext('/tmp/bb') )
('/tmp/bb', '')

'''		
class ZZCFichiers(object):
	def __init__(self,fich=''):
		Tprint('fich.__init__()')
		self._SEP='/'	
		self._fich=fich
		pass#self._repertoire=_rep
	def Valide(self):
		Tprint('fich.Valide()')
		resultat=None
		if os.path.isfile(self._fich):
			resultat=True
		if not os.path.isfile(self._fich):
			resultat=False
		return resultat
	def RepNom(self):#'/tmp'
		Tprint('fich.RepNom()')
		self._RepNom=os.path.split(self._rep)[0]
		return self._RepNom
	def FichNom(self):#bb.jpg
		Tprint('fich.FichNom()')
		self._FichNom=os.path.split(self._rep)[1]
		return self._FichNom
		

class ZZCRepertoires(object):
	def __init__(self,rep=''):
		self._SEP='/'	
		self._Fichs=[]
		self._FichsRec=[]
		self._Reps=[]
		self._RepsRec=[]		
		while rep[-1]==self._SEP:
			rep=rep[:-1]
		self._rep=rep
		pass
		
	def Valide(self):
		Tprint('rep.Valide()')
		resultat=None
		if os.path.isdir(self._rep):
			resultat=True
		if not os.path.isdir(self._rep):
			resultat=False
		return resultat
		
	def Contenu(self):		
		Tprint('rep.Contenu()')
		for root, reps, files in os.walk(self._rep):
			for fich in files: #page038.jpg 
				self._FichsRec.append(CFichiers(os.path.join(root, fich)))	
				fullurl = os.path.join(root, fich) #/home/aa/Tome1/page038.jpg
				print(fullurl)
			for rep in reps:
				self._RepsRec.append(CRepertoires(os.path.join(root, rep)))	
				fullurl = os.path.join(root, rep) #/home/aa/Tome1/page038.jpg
				print(fullurl)
				
	def RepNom(self):#'/tmp'
		Tprint('rep.RepNom()')
		self._RepNom=os.path.split(self._rep)[0]
		return self._RepNom
		
	def FichNom(self):#rep1
		Tprint('rep.FichNom()')
		self._FichNom=os.path.split(self._rep)[1]
		return self._FichNom
				
					


#self.thumbs=os.listdir(rep)
#(os.path.splitext(i)[1])[1:]
#self.thumbs=[ i for i in self.thumbs if ((os.path.splitext(i)[1])[1:]).lower() in SuffixesImages ]		#AfficheImagesAvecLegendes

	
global main

if __name__ == "__main__":
	Dprint("Le programme lancé est "+sys.argv[0])
	
	print(_FonctionDuProgramme)
	print("version:"+_Version)

	
	print('import CGeometrie')
	print('from CFichiersRepertoires import CFichiersRepertoires,CFichiers')
	print('fich=CFichiers(nomfich)')
	print('  fich._SEP')
	print('  fich._fich , fich.Valide() , fich.RepNom() ,	fich.FichNom()')
	print('rep=CFichiers(nomrep)')
	print('  rep._SEP , rep.Contenu() ')
	print('  rep._rep , rep.Valide() , rep.RepNom() ,	rep.FichNom()')
	
	print(dir(CPoint()))
	a=5
	print(dir(a))
	sys.exit()


