#!/usr/bin/python3
# -*- coding: iso-8859-15 -*-
from __future__ import print_function
_FonctionDuProgramme="Classe traduisant les fichiers"
#print(_FonctionDuProgramme)
_Version="16.0.2"

#voir dictionnaireV16.dia

'''
 rajouter : 
	LexiqueGenre-UTF8.txt : genre des mots machin#m : {mot}#{m|f|rien=m+f}
	LexiqueAdverbe-UTF8.txt : a capella : {mot}
	Lexique380-UTF8.txt :
tt	ota	ter	VER			16.81	42.03	0.00	0.14	sub:imp:3s;	1	2	0	4	3	VCVC	VCV	0	18	0	0	o-ta	2	V-CV	tt	ato	-tt	VER	89	28	2	1	ter	1
t	ote	ter	VER	m	s	16.81	42.03	3.18	5.47	par:pas;	2	11	0	3	3	VCV	VCV	3	19	3	3	o-te	2	V-CV	t	eto	-t	VER,ADJ	89	28	1.65	1	t	1
	
'''

""" UTILISATION :
V16	deplacement des dicohpysique et dicosblender dans sous-repertoire
	ajout de groupes de phrases
V15 tentative d utilisation des propositions
V14.2  TraduitFormules MTW
V14.1 : abandonn
V14 utilisation de plusieurs dictionnaires : self.DicoAdditionnels()
V13.1 self._FichierTraduit=self.TraduitUnFichier(fichier) 
V13 : ajout de PrepareLigne et propositions dans =>Traduit
import dictionnaire
dico=br_Cdictionnaire()
LigneTraduite=dico.Traduit(LigneATraduire)
"""



"""
Tprint() : affiche titres
Dprint() : affiche debug

br_Cdictionnaire.trans : tous les couples de mots
br_Cdictionnaire.DicoAdditionnel #AJOUT DE MOTS [mo,po] dans un dico non prpar
br_Cdictionnaire.CreeDictionnaire #rempli self.trans=[[motEng,motFr] ]
br_Cdictionnaire.CreePlurielsEnS4 #AJOUT DE MOTS AVEC UN s FINAL [mo,po] -> [mos,pos]
br_Cdictionnaire.CreeDictionnairePhysique #AJOUT DE MOTS [mo,po]
br_Cdictionnaire.CreeDictionnaireBlender #AJOUT DE MOTS [mo,po]

br_Cdictionnaire.PremieresTraductions #specialites anglaises a pr traduire

br_Cdictionnaire.DernieresTraductions #specialites francaises a post traduire
br_Cdictionnaire.Range # ordonn par longueur en anglais puis alphabtiquement
br_Cdictionnaire.Uniq #s'assure de l'unicit
br_Cdictionnaire.ChercheUnMot #chercher un mot
br_Cdictionnaire.Traduit # Traduit une ligne
br_Cdictionnaire.Traduit43 # COEUR DE LA TRADUCTION
"""
import re,os,sys
from string import capwords
##################### debug
_debug=False # _debug=True
_debug_Titres=False # _debug_Titres=True 
def Tprint(*args, **kwargs):
	if _debug_Titres==True:
		print(*args, **kwargs)	
"""
if _debug==True:
	_FichierLOG=open('traducteur.log','w')
"""
_FichierLOG=open('/tmp/'+sys.argv[0]+'.log','w')

def Dprint(*args, **kwargs):
	if _debug==True:
		print("debug:",*args, **kwargs)

def LenPrint(*args):
	if _debug==True:
		print("LenPrint:",*args,len(*args),file=_FichierLOG)

def TradPrint(*args, **kwargs):
	if _debug==True:
		print("TRAD:",*args, **kwargs)		
		
def ErrPrint(*args, **kwargs):
	print("ErrPrint:",*args, **kwargs)
	
def TraduitUnFichierPrint(*args, **kwargs):
	print("TRAD:",*args, **kwargs)	

##################### CLASSE PRINCIPALE : br_Cdictionnaire
class br_Cdictionnaire(object):
	def __init__(self,auto=True):
		""" br_Cdictionnaire.__init__() """
		Tprint('\n-* br_Cdictionnaire.__init__()')
		self.trans=[]
		if auto==True:
			self.CreeDictionnaire()						
					
	def DicoAdditionnels(self):
		Tprint('-** br_Cdictionnaire.DicoAdditionnels()')
		rep='dictionnaires_additionnels/'
		dicos=[rep+'MTW04.txt',rep+'MTW07.txt',rep+'dico_additionnel.txt',rep+'dico_additionnel-zola-jaccuse.txt','LIVRES/lepetit prince/dico_additionnel-lepetitprinceChap01.txt']
		dicos=[rep+'MTW_sommaire-fr.txt',rep+'MTW_21-40.txt',rep+'MTW_01-20.txt',rep+'dico_additionnel.txt',rep+'dico_additionnel-zola-jaccuse.txt',rep+'dico_additionnel-lepetitprinceChap01.txt']
		dicos+=[rep+'MTW.txt',rep+'dico_additionnel-physique.txt']
		dicos+=[rep+'MTW.txt',rep+'dico_additionnel-physique.txt']
		dicos+=[rep+'dico_additionnelV16.txt',rep+'dico-linux.txt']
		dicos+=[rep+'DictionnairePhysique',rep+'DictionnaireBlender']
		Dicoadd=[]
		for dico in dicos:
			Dicoadd+=self.DicoAdditionnel(dico)
		return Dicoadd
			
		
		
	def DicoAdditionnel(self,fich='dico_additionnel.txt'): #AJOUT DE MOTS [mo,po] dans un dico non prpar
		Tprint('-** br_Cdictionnaire.DicoAdditionnel("'+fich+'")')
		#'nom eng, nom fran' V8
		# ne pas commencer par a ou an ou the
		Tprint('-*** init br_Cdictionnaire.DicoAdditionnel:',fich)		
		DicoAdd=[]
		if os.path.isfile(fich):
			f= open(fich,'r')
			for ligne in f.readlines():			
				if '#' in ligne:
					tmp=ligne.split('\n')[0].split('#')
					DicoAdd+=[(tmp[0],tmp[1])]
					Dprint('** '+tmp[0]+'=>'+tmp[1])
			f.close()
		else:
			ErrPrint('le fichier "'+fich+'" n\'existe pas.')			
			
		fich='dictionnaires_additionnels/dico_additionel-formules.txt'
		DicoFormules=[]
		if os.path.isfile(fich):
			f= open(fich,'r')
			for ligne in f.readlines():
				if '#' in ligne:
					tmp=ligne.split('\n')[0].split('#')
					DicoFormules+=[(tmp[0],tmp[1])]
					#DicoFormules+=[(tmp[0].replace('\\','\\\\'),tmp[1])]
					#DicoFormules+=[(tmp[0].replace(')','\)'),tmp[1])]
					#DicoFormules+=[(tmp[0].replace('(','\('),tmp[1])]
					Dprint('** '+tmp[0]+'=>'+tmp[1])
			f.close()
		else:
			ErrPrint('le fichier "'+fich+'" n\'existe pas.')
		self._DicoFormules=DicoFormules
		return DicoAdd
	
	
	
	
	
	def CreeDictionnaire(self):#rempli self.trans=[[motEng,motFr] ]
		Tprint('-** br_Cdictionnaire.CreeDictionnaire')
		
		#AJOUT DE MOTS [mo,po]
		Phys=self.CreeDictionnairePhysique() #self.trans=Phys
		#AJOUT DE MOTS [mo,po]
		Blender=self.CreeDictionnaireBlender() #self.trans=Phys+Blender		
		#AJOUT DE MOTS [mo,po] dans un dico non prpar		
		#DicoAdd=self.DicoAdditionnel('dico_additionnel.txt')
		#DicoAdd+=self.DicoAdditionnel('dico_additionnel-zola-jaccuse.txt')
		DicoAdd=self.DicoAdditionnels()
		self.trans=Phys+Blender+DicoAdd
		#AJOUT DE MOTS AVEC UN s FINAL [mo,po] -> [mos,pos]
		Pluriels=self.CreePlurielsEnS4()
		self.trans+=Pluriels
		"""
		self.trans=[('one can', 'on peut')]+[('zzzzzzz', 'zzzzzzzz')]

		"""
		self.Range()
		return self.trans
	
	def EnregistreDictionnaire(self):
		Tprint('-** br_Cdictionnaire.EnregistreDictionnaire')
		f=open('/tmp/DicoEnCours',"w")
		print(self.trans,file=f)
		f.close()
		
	
	def CreePlurielsEnS4(self):#AJOUT DE MOTS AVEC UN s FINAL [mo,po] -> [mos,pos]
		Tprint('-*** br_Cdictionnaire.CreePlurielsEnS4')
		Pluriels=[]
		for l in self.trans:
			try:
				if l[0][-1]!='s':			
					Pluriels+=[(l[0]+'s',l[1]+'s')]
			except:
				print(l)		
		#self.trans+=Pluriels
		
		return Pluriels
		
			
	def CreeDictionnairePhysique(self):#AJOUT DE MOTS [mo,po]
		Tprint('-*** br_Cdictionnaire.CreeDictionnairePhysique : obsolete')
		physique=[]
					

		#self.trans+=physique
		return physique

	
	def CreeDictionnaireBlender(self):#AJOUT DE MOTS [mo,po]
		Tprint('-*** br_Cdictionnaire.CreeDictionnaireBlender : obsolete')
		blender=[]		
		#self.trans+=blender
		return blender


	def Range(self,croissant=True):# ordonn par longueur en anglais puis alphabtiquement
		Tprint('-*** br_Cdictionnaire.Range')
		self.trans=sorted ( self.trans , key=lambda tabl: tabl[0] , reverse=croissant )
		self.trans=sorted ( self.trans , key=lambda tabl: len(tabl[0] ) ,reverse=croissant)
		self.Uniq()
		return self.trans
	
		
	def Uniq(self): #s'assure de l'unicit
		Tprint('-**** br_Cdictionnaire.Uniq')
		for no in range(len(self.trans)-1,0-1,-1):
			if self.trans[no]==self.trans[no-1]:
				Dprint('----',self.trans[no],' est en double')
				del self.trans[no]
		return self.trans	
	
	def ZZPremieresTraductions(self,ligne):#specialites anglaises a pr traduire
		Tprint('-** br_Cdictionnaire.PremieresTraductions V<=15')
				
		#ligne=self.TraduitFormules(ligne)
		
		self._PTdivers=[]				
		self._PTdivers+=[("([^a-zA-Z])([a-zA-Z]*)'s ([a-zA-Z]*)([^a-zA-Z])","\g<1>\g<3> de \g<2>\g<4>")]
		self._PTdivers+=[("([^a-zA-Z])a([^a-zA-Z])","\g<1>un\g<2>")]
		self._PTdivers+=[("([^a-zA-Z])an([^a-zA-Z])","\g<1>un\g<2>")]		
		self._PTdivers+=[("([^a-zA-Z])'ll([^a-zA-Z])","\g<1> will\g<2>")]
		
		self._PTdivers+=[(chr(8212),'"')]
		self._PTdivers+=[(chr(8216),"'")]

		#self._PTdivers+=[('\x8094','-')]
		for t in self._PTdivers:
			ligne=re.sub(t[0],t[1],ligne)
		return ligne

	def PremieresTraductions(self,ligne):#specialites anglaises a pr traduire
		Tprint('-** br_Cdictionnaire.PremieresTraductions V>=16')
				
		#ligne=self.TraduitFormules(ligne)
		
		self._PTdivers=[]				
		self._PTdivers+=[("([^a-zA-Z])([a-zA-Z]*)'s ([a-zA-Z]*)([^a-zA-Z])","\g<1>\g<3> de \g<2>\g<4>")]
		#self._PTdivers+=[("([^a-zA-Z])a([^a-zA-Z])","\g<1>un\g<2>")]
		#self._PTdivers+=[("([^a-zA-Z])an([^a-zA-Z])","\g<1>un\g<2>")]		
		self._PTdivers+=[("([^a-zA-Z])'ll([^a-zA-Z])","\g<1> will\g<2>")]
		
		self._PTdivers+=[(chr(8212),'"')]
		self._PTdivers+=[(chr(8216),"'")]

		#self._PTdivers+=[('\x8094','-')]
		for t in self._PTdivers:
			ligne=re.sub(t[0],t[1],ligne)
		return ligne
	
	def TraduitFormules(self,ligne):
		for t in self._DicoFormules:
			#print("=============",ligne,"===========")
			#print("=============",t[0],"===========")
			ligne=ligne.replace(t[0],t[1])
			#print(ligne)
		return ligne
		
		
	def DernieresTraductions(self,BLOC):#specialites francaises a post traduire
		Tprint('-** br_Cdictionnaire.DernieresTraductions V>=16')
		self._DTPremieresContractions=[]
		self._DTPremieresContractions+=[("([^a-zA-Z])le ([aeiouyAEIOUY])","\g<1>l'\g<2>")]
		self._DTPremieresContractions+=[("([^a-zA-Z])la ([aeiouyAEIOUY])","\g<1>l'\g<2>")]
		
		for t in self._DTPremieresContractions:
			#print((t[0],t[1],ligne))
			BLOC=re.sub(t[0],t[1],BLOC)
		
		self._AnglaisNOnTraduit=[]
		#self._AnglaisNOnTraduit+=[('','')]
		self._AnglaisNOnTraduit+=[("i ont","j'ai")]
		
		for t in self._AnglaisNOnTraduit:
			BLOC=re.sub('([^a-zA-Z])'+t[0]+'([^a-zA-Z])','\g<1>'+t[1]+'\g<2>',BLOC)
			
			
		self._DTContractions=[]
		self._DTContractions+=[('de le','du')]
		self._DTContractions+=[('de les','des')]
		self._DTContractions+=[(' le','au')]
		self._DTContractions+=[(' les','aux')]
		self._DTContractions+=[("de o","d'o")]
		self._DTContractions+=[("de un","d'un")]
		self._DTContractions+=[("de une","d'une")]
		self._DTContractions+=[("ce est","c'est")]
		self._DTContractions+=[("Ce est","C'est")]
		self._DTContractions+=[("son la","sa")]
		
		for t in self._DTContractions:
			BLOC=re.sub('([^a-zA-Z])'+t[0]+'([^a-zA-Z])','\g<1>'+t[1]+'\g<2>',BLOC)
			
			
		
		self._erreurs=[]
		self._erreurs+=[("le ce","ce")]
		self._erreurs+=[("ce spare","cette sparation")]
					
		for t in self._erreurs:
			BLOC=re.sub('([^a-zA-Z])'+t[0]+'([^a-zA-Z])','\g<1>'+t[1]+'\g<2>',BLOC)
			

		
		
		

		"""
		self._Tex=[]
		self._Tex+=[(chr(92)+'commencer',chr(92)+'begin{')]
		self._Tex+=[('\tiqueter{','\label{')]
		self._Tex+=[('\fin{','\end{')]
		for t in self._Tex:
			ligne=re.sub('([^a-zA-Z])'+t[0]+'([^a-zA-Z])','\g<1>'+t[1]+'\g<2>',ligne)
		"""	
			
		'''			V16
		Erreurs=[('faSur','faon')]
		for t in Erreurs:
			ligne=re.sub(t[0],t[1],ligne)
		'''
		return BLOC	
		
	def ChercheUnMot(self,mot='gravitation',MotExacte=False):#chercher un mot
		Tprint('-** br_Cdictionnaire.ChercheUnMot')
		Traduction_Exacte=[]
		mot=mot.lower()
		print('\nrecherche du mot '+mot)
		for mots in self.trans:
			if mot==mots[0].lower() or mot==mots[1].lower():
				Traduction_Exacte.append(mots)
			
			if mot in mots[0].lower() or mot in mots[1].lower():
				print(' rsultat de la recherche :'+'"'+mots[0]+'"'+"=>"+'"'+mots[1]+'"')
			else:
				if MotExacte==False:
					if mot in mots[0].lower()[0:-1] or mot in mots[1].lower()[0:-1] or mot[0:-1] in mots[0].lower() or mot[0:-1] in mots[1].lower():
						print(" rsultat approximatif : "+mots[0]+" => "+mots[1])
		print('traduction exacte:',Traduction_Exacte)
		print('fin de recherche du mot '+mot)	
	
	def PrepareLigne(self,ligne):
		Tprint('-*** br_Cdictionnaire.PrepareLigne V>=16')
		ligne=' '+ligne.strip()+' '
		'''
		ponctuations=[',','\?','.',';','/',':','\!']
		for ponctuation in ponctuations:
			print('-------------------',ponctuation)
			ligne=re.sub(ponctuation,' '+ponctuation+' ',ligne)
		'''	
		return ligne		

	def TraduitTex(self,LigneATraduire):# Traduit une ligne
		Tprint('-** init br_Cdictionnaire.Traduit des lignes tex')
		_TraduitDesLeDebut=False
		
		
		
		
		
		propositions=[LigneATraduire]
		_LigneTraduite=''
		
		for proposition in propositions:
			LigneTraduite=proposition
			LigneTraduite=self.PrepareLigne(LigneTraduite)			
			LigneTraduite=self.PremieresTraductions(LigneTraduite)
			
			LigneTraduite=self.Traduit43(LigneTraduite)
			
			if LigneTraduite!=False:
				LigneTraduite=self.DernieresTraductions(LigneTraduite)
				LigneTraduite=LigneTraduite+','
			else:
				LigneTraduite=proposition
			_LigneTraduite+=LigneTraduite
		return _LigneTraduite[0:-1]
	
	def ZZTraduit(self,LigneATraduire):# Traduit une ligne
		Tprint('-** br_Cdictionnaire.Traduit une ligne V<=15')
		#LigneATraduire=' '+LigneATraduire.lower()+' ' # on rajoute 2 espaces
		#LigneATraduire=self.ApostropheS(LigneATraduire)
		LigneATraduire=self.TraduitFormules(LigneATraduire)
		#propositions=LigneATraduire.split(',')
		propositions=[LigneATraduire]
		_LigneTraduite=''
		
		for proposition in propositions:
			LigneTraduite=proposition
			LigneTraduite=self.PrepareLigne(LigneTraduite)			
			LigneTraduite=self.PremieresTraductions(LigneTraduite)
			
			LigneTraduite=self.Traduit43(LigneTraduite)
			#LigneTraduite,BlocEnCoursDeTraduction,BlocEnCoursDeTraductionMinuscules,BlocsTraduits = self.Traduit16(LigneTraduite)#V16
			
			if LigneTraduite!=False:
				#print('--a',LigneTraduite)
				LigneTraduite=self.DernieresTraductions(LigneTraduite)
				LigneTraduite=LigneTraduite+','
				#print('--r',LigneTraduite)
			else:
				LigneTraduite=proposition
			_LigneTraduite+=LigneTraduite
		#print('--t',_LigneTraduite)	
		return _LigneTraduite[0:-1]

	def Traduit(self,LigneATraduire):# Traduit une ligne
		Tprint('-** br_Cdictionnaire.Traduit une ligne V>=16')		
		LigneATraduire=self.TraduitFormules(LigneATraduire)
		
		_LigneTraduite=''
		
		LigneATraduire=self.PrepareLigne(LigneATraduire)		
		LigneATraduire=self.PremieresTraductions(LigneATraduire)
		LigneTraduite,BlocEnCoursDeTraduction,BlocEnCoursDeTraductionMinuscules,BlocsTraduits = self.Traduit16(LigneATraduire)#V16
			
		#pas de majuscules/minuscules
		#_LigneTraduite=""
		for No in range(len(BlocEnCoursDeTraduction)):
			bloc=BlocEnCoursDeTraduction[No]
			if BlocsTraduits[No]==True:#on a du francais
				BlocEnCoursDeTraduction[No]=self.DernieresTraductions(bloc)
		
		_LigneTraduite=""
		for l in BlocEnCoursDeTraduction:
			_LigneTraduite+=l.lstrip()
		return _LigneTraduite
		
		
		
		
		
				
	
	def TraduitUnFichier(self,fichier):
		self._FichierTraduit=''
		if os.path.isfile(fichier):
			f=open(fichier,'r')
			for line in f:
				'''
				if self._tesseract==True:
					self._FichierTraduit+=self.Traduit(line)
				#TraduitUnFichierPrint(line)
				if self._tesseract==False:
					self._FichierTraduit+=self.Traduit(self.Tesseract(line))
				'''
				self._FichierTraduit+=self.Traduit(line)
			f.close()	
		return self._FichierTraduit
		

		
	

######################### COEUR DE LA TRADUCTION ########################	

	def Traduit16(self,LigneATraduire): #V16 #COEUR DE LA TRADUCTION
		Tprint('-** br_Cdictionnaire.Traduit16 V16')		
		#_TraductionFaite=False # au cas ou tous les mots traduits sont identiques en fr et us 
		#V<=16.0.0 BlocEnCoursDeTraduction=[' '+LigneATraduire[0:-2].strip()+' ']# on rajoute 2 espaces V4.1
		BlocEnCoursDeTraduction=[' '+LigneATraduire.strip()+' ']# #V16.0.1
		BlocEnCoursDeTraductionMinuscules=[BlocEnCoursDeTraduction[0].lower()]# on rajoute 2 espaces V4.1
		BlocsTraduits=[False]
		
		LenPrint("LigneATraduire="+LigneATraduire)
		
		for mots in self.trans:
			NoBloc = len(BlocEnCoursDeTraduction) - 1
			while NoBloc!=-1:							
				#for NoBloc in range(len(BlocEnCoursDeTraduction)-1,0-1,-1):
				Bloc     = BlocEnCoursDeTraduction[NoBloc]
				BlocMinus= BlocEnCoursDeTraductionMinuscules[NoBloc]
				#if BlocsTraduits[NoBloc]==False and mots[0] in BlocMinus:
				if BlocsTraduits[NoBloc]==False and mots[0]==re.sub("(.*)([^a-zA-Z])("+mots[0]+")([^a-zA-Z])(.*)",'\g<3>',BlocMinus):#V16.0.1
					
					LenPrint(BlocEnCoursDeTraduction)
					LenPrint(BlocEnCoursDeTraductionMinuscules)
					LenPrint(BlocsTraduits)
					LenPrint("NoBloc="+str(NoBloc))
					LenPrint("mots[0]="+mots[0])
					LenPrint("mots[1]="+mots[1])
					#LenPrint('BlocMinus='+BlocMinus,file=_FichierLOG)
					#BlocsTraduits=BlocsTraduits[0:NoBloc-1] +[False,True,False] + BlocsTraduits[NoBloc+1:len(BlocsTraduits)]
					
					##LenPrint(Bloc,file=_FichierLOG)
					##LenPrint(BlocMinus,file=_FichierLOG)
					#LenPrint(NoBloc,file=_FichierLOG)
					
					
					# optimiser en une Bloc , autre re.
					AvantMin=re.sub("(.*)([^a-zA-Z])("+mots[0]+")([^a-zA-Z])(.*)",'\g<1>\g<2>',BlocMinus)
					LenPrint("AvantMin="+AvantMin)
					ApresMin=re.sub("(.*)([^a-zA-Z])("+mots[0]+")([^a-zA-Z])(.*)",'\g<4>\g<5>',BlocMinus)
					#re.sub("(.*)([^a-zA-Z])("+mots[0]+")([^a-zA-Z])(.*)",'\g<3>',BlocMinus)
					MilieuMaj=self.MajMin(Bloc[len(AvantMin):len(BlocMinus)-len(ApresMin)] , mots[0] ,mots[1] )
					##LenPrint('$',MilieuMaj,'$',file=_FichierLOG)
					AvantMaj=" "+Bloc[:len(AvantMin)].strip()+" "
					ApresMaj=" "+Bloc[len(BlocMinus)-len(ApresMin):].strip()+" "
					MilieuMaj=" "+MilieuMaj.strip()+" "
					
					DeltaNoBloc=2
					Ajout=[]
					AjoutBool=[]
					if AvantMaj=="  ":
						DeltaNoBloc-=1
					else:
						Ajout=[AvantMaj]
						AjoutBool=[False]
					Ajout+=[MilieuMaj]
					AjoutBool+=[True]
					if ApresMaj=="  ":
						DeltaNoBloc-=1
					else:
						Ajout+=[ApresMaj]	
						AjoutBool+=[False]
					AjoutMin=[i.lower() for i in Ajout]
					
					LenPrint(	str(len(AjoutMin)))

					BlocsTraduits=BlocsTraduits[0:NoBloc] *(NoBloc>=1) + AjoutBool+ BlocsTraduits[NoBloc+1:len(BlocsTraduits)]
						
					#BlocEnCoursDeTraduction=BlocEnCoursDeTraduction[0:NoBloc-1] + [AvantMaj,MilieuMaj,ApresMaj] + BlocEnCoursDeTraduction[NoBloc+1:len(BlocEnCoursDeTraduction)]	
										
					BlocEnCoursDeTraduction=BlocEnCoursDeTraduction[0:NoBloc] *(NoBloc>=1) + \
					Ajout + \
					BlocEnCoursDeTraduction[NoBloc+1:len(BlocEnCoursDeTraduction)]	
					##LenPrint("="+AvantMin+"="+ApresMin+"=",file=_FichierLOG)
					
					BlocEnCoursDeTraductionMinuscules=BlocEnCoursDeTraductionMinuscules[0:NoBloc] *(NoBloc>=1)+ \
					AjoutMin + \
					BlocEnCoursDeTraductionMinuscules[NoBloc+1:len(BlocEnCoursDeTraductionMinuscules)]
					
					#LenPrint(BlocEnCoursDeTraduction,file=_FichierLOG)
					##LenPrint(BlocEnCoursDeTraductionMinuscules,file=_FichierLOG)
					
					
					# MotTraduit)+'\g<3>',BlocMinus)
					
					NoBloc=min(NoBloc+DeltaNoBloc,len(BlocEnCoursDeTraduction)-1)#2
					LenPrint(BlocEnCoursDeTraduction)
					LenPrint(BlocEnCoursDeTraductionMinuscules)
					LenPrint(BlocsTraduits)
					LenPrint("NoBloc="+str(NoBloc))
					LenPrint("-----------------------------------")
				else:
					NoBloc-=1


		#print('fini')
		LigneTraduite=''
		for l in BlocEnCoursDeTraduction:
			LigneTraduite+=l.lstrip()
		#LigneTraduite=self.DernieresTraductions(LigneTraduite)
		LigneTraduite=LigneTraduite.strip()#[1:-1]
		return LigneTraduite,BlocEnCoursDeTraduction,BlocEnCoursDeTraductionMinuscules,BlocsTraduits
	
	
					
	def MajMin(self,EngMaj,EngMin,FrMin):#travaille sur la place des majuscules				
		
		if EngMaj.upper()==EngMaj:
			retour=FrMin.upper()
		else:
			initiales=self.Initiales(EngMaj)
			if initiales.upper()==initiales:
				retour=capwords(FrMin)#re.sub(' (\S)',' \g<1>',FrMin).upper()
			else:
				retour=FrMin		
				
		return retour
		
	def Initiales(self,mots): #  T C i k 
		Tprint('-** br_Cdictionnaire.Initiale') 
		return re.sub('([\S])[\S]*','\g<1>',mots)#return re.sub('([a-zA-Z])[a-zA-Z]*','\g<1>',mots)
		
	def ZZTraduit43(self,LigneATraduire): #V4.3COEUR DE LA TRADUCTION
		Tprint('-** br_Cdictionnaire.Traduit43 V4.3') 
		def eprint(phrase):
			return TradPrint(phrase)
			"""
			if True==False:
				print(phrase)
			"""	
		_TraductionFaite=False # au cas ou tous les mots traduits sont identiques en fr et us 
		LigneTraduite=' '+LigneATraduire.lower()+' ' # on rajoute 2 espaces V4.1
		
		for mots in self.trans:
			if mots[0] in LigneTraduite:	
							
				#TradPrint(LigneTraduite,mots[0])
				Initiales=[]	
				if mots[0]==mots[1]:
					_TraductionFaite=True 
				
				if mots[0] in LigneATraduire: #minuscules
					MotTraduit=mots[1]
				else:
					MotTraduit=mots[1][0].upper()+mots[1][1:]	
				
				####################################### !!!!!!!!!!
				#sur ces deux lignes il faudrait mettre les lettres accentues	
				#print('1LigneTraduite',LigneTraduite,mots,'==')	
				LigneTraduite=re.sub("([^a-zA-Z])("+mots[0]+")([^a-zA-Z])",'\g<1>'+MotTraduit+'\g<3>',LigneTraduite)
				#print('2LigneTraduite',LigneTraduite,mots,'==')	
				LigneTraduite=re.sub("([^a-zA-Z])("+mots[0]+"s)([^a-zA-Z])",'\g<1>'+MotTraduit+'s\g<3>',LigneTraduite)
				#print('3LigneTraduite',LigneTraduite,mots,'==')	
				
				#TradPrint(LigneTraduite)
		LigneTraduite=self.DernieresTraductions(LigneTraduite)
		LigneTraduite=LigneTraduite[1:-1] # on enleve les 2 espaces
		#print('4LigneTraduite',LigneTraduite,mots,'==')	
		if _TraductionFaite==True or LigneTraduite!=LigneATraduire.lower():
			if LigneATraduire[0].isupper():
				LigneTraduite=LigneTraduite[0].upper()+LigneTraduite[1:]
			Initiales=re.sub("([^a-zA-Z])([a-zA-Z])[a-zA-Z]*([^a-zA-Z])","\g<1>\g<2>\g<3>",		re.sub("([a-zA-Z]) ","\g<1>  "," "+LigneATraduire+" "))#rajout d'un espace
			return LigneTraduite
		else:
			return False

class br_CDICO(dict):
	  def __missing__(self, key):
		  return ""

if __name__=='__main__':
	
	print("Le programme lanc est "+sys.argv[0])
	print(_FonctionDuProgramme)
	print("version:"+_Version)
	
	print("le fichier FichierATraduire.txt est traduit en FichierTraduit.txt")
	
	print("On peut aussi simplement chercher un mot dans la base : dico.ChercheUnMot('heavy',True) ")
	#exit('utiliser la V15')
	dico=br_Cdictionnaire(False)
	#dico.DicoAdditionnel('dico_additionnel.txt')
	dico.CreeDictionnaire()
	
	
	dico._tesseract=False #ne marche pas
	#print(dico.Traduit('Just as one can "descend" from general relativity to linearized theory by linearizing about flat spacetime (see below), so one can "bootstrap" one\'s ways back up from linearized theory to general relativity by imposing consistency between the linearized field equations and the equations of motion'))
	dico.TraduitUnFichier("FichierATraduire.txt")
	#print(dico.TraduitUnFichier("LIVRES/Zola-JAccuse-en.txt"))
	
	fich='FichierTraduit.txt'
	print('cration du fichier '+fich)
	f=open(fich,'w')
	print(dico._FichierTraduit,file=f)
	f.close()
	
	#print(dico.Traduit(' way '))
	
	#dico.ChercheUnMot('preserve',False)
	
	"""
	for nom in ['gravitation_MTW_35-28.texte.txt','gravitation_MTW_35-29.texte.txt','gravitation_MTW_35-30.texte.txt','gravitation_MTW_35-31.texte.txt','gravitation_MTW_35-32.texte.txt']:
		dico.TraduitUnFichier("/tmp/aa/"+nom)
		#print(dico.TraduitUnFichier("LIVRES/Zola-JAccuse-en.txt"))
		
		fich='/tmp/aa/'+nom+".fr"
		print('cration du fichier '+fich)
		f=open(fich,'w')
		print(dico._FichierTraduit,file=f)
		f.close()
	"""
	
	
	
	print( '################################')
	dico.ChercheUnMot('heavy',True)
	
	
	'''
	########## fichier ENG#FR
	f1=open("fichieratraduire",'r')
	f2=open(fich,'r')
	l1=l2=lignes=[]
	for line in f1:
		l1.append(line)
	for line in f2:
		l2.append(line)
	print(len(l1),len(l2))
	g=open('/tmp/cc','w')
	for i in range(829):
		tmp=l1[i]+'#'+l2[i]
		#lignes.append(l1[i]+'#'+l2[i])
		print(tmp,file=g)	
	'''	

	
	#print([i for i in dico.trans if 'Theorem' in i])
	exit()

'''
a faire
by +ing
.po : cat Bureau/TraductionDeBlender/essai/particle_system_panel.po.po |grep -v '^#: ' |sed ':s;N;s/\n/ /;bs' |sed 's/msgid/\n\nmsgid/g' |grep msgstr |sed 's/msgid\ "\(.*\)"\ msgstr\ "\(.*\)"/\1#\2/' |grep -v "^#"
'''
