#!/usr/bin/python2
# -*- coding: utf-8 -*-
#from __future__ import print_function
_FonctionDuProgramme="differentes fonctions utilisables"
#print(_FonctionDuProgramme)
_Version="3.0.3"
"""
1.0.3 : IntHex
1.0.1 md5 : renvoir time .time() si erreur
"""
#print("version:"+_Version)
import re
import os
##################### debug
import sys

_debug_Titres=True # _debug_Titres=False
_debug_all=True # 
_debug_all=False

if _debug_all==True:
	_debug_Titres=True

if _debug_Titres==True:
	_FichierLog='/tmp/'+re.sub('.*/','',sys.argv[0])+'.log'
	_Log=open(_FichierLog,'w')

def Tprint(*args, **kwargs):
	if _debug_Titres==True:
		print(*args, **kwargs)					
		print(*args,file=_Log)
def Dprint(ligne):
	if _debug_all==True:
		print(ligne)
		print('--------------------------')
# # # # # # # # # # # # # # # # # # # debug
# ajout de doc + Tprint sed -e 's/^\(.*\)\(def\ \)\(.*\)$/\1\2\3\n\1\t"""-*\3"""\n\1\tTprint("\3")/' -i aa.py
class br_CDICO(dict):
	  def __missing__(self, key):
		  return ""

class CMachin(object):
	""" CLASSE CMachin(object) """
	def __init__(self,_rep=''):
		pass#self._repertoire=_rep
		
'''
print ( os.path.split('/tmp/bb.jpg') )
('/tmp', 'bb.jpg')
print ( os.path.splitext('/tmp/bb.jpg') )
('/tmp/bb', '.jpg')


print ( os.path.split('/tmp/bb/') )
('/tmp/bb', '')
print ( os.path.splitext('/tmp/bb/') )
('/tmp/bb/', '')



print ( o.split('/tmp/bb') )
('/tmp', 'bb')
print ( os.path.splitext('/tmp/bb') )
('/tmp/bb', '')

'''		
DicoFonctions=br_CDICO()

def	TableauToString(tablo,sep=""):
	''' TableauToString(tablo,sep="") : tableau de string devient une string 
	retourne str||None 
	'''
	texte=""
	for t in tablo:
		if isinstance(t,str):
			texte+=t+sep
		else:
			return None	
	return texte	
DicoFonctions["TableauToString"]=TableauToString.__doc__


#1.0.5 def Md5(fname):	''' str Md5('nom fich') '''
def Md5(fname,Impossible="time"):	
	''' Md5('nom fich' , Impossible="time" ) 
	retourn str||time()||\"\" '''
	import hashlib
	hash_md5 = hashlib.md5()
	try:
		with open(fname, "rb") as f:
			for chunk in iter(lambda: f.read(4096), b""):
				hash_md5.update(chunk)
		return hash_md5.hexdigest()
	except:
		if Impossible=="time":
			from time import time
			return str(time())
		else:
			return ""
DicoFonctions["Md5"]=Md5.__doc__




def HexsInt(hexa,N=1):
	""" transforme des blocs d'hexadecimaux de longueur N en entiers """
	res=[]
	for i in range(0,len(hexa),N):
		hexaN=hexa[i:i+N]
		"""
		nb=0		
		for j in range(N):
			nb=nb*16+HexInt(hexaN[j])
		"""	
		nb=HexInt(hexaN)
		res+=[nb]
	return res	
DicoFonctions["HexInt"]=HexsInt.__doc__	

def IntHex(entier,N=-1,res=""):
	""" transforme un entier en hexadecimal de longueur N"""	
	
	if int(entier)==entier and entier>=0 and entier<=15:
		if entier>=0 and entier<=9:
			res=res+str(entier)
		else:
			res=res+chr(55+entier)
		entier=0
		if N!=-1:
			res="0"*(int((N-1)/N)*N-1)		
		
	if entier!=0:
		M=int(math.log10(entier)/math.log10(16))
		if N!=-1:
			res="0"*(int((N+M-1)/N)*N-(M+1))				
		aM=int(entier/16**M)
		res=res+IntHex(aM)
		res=IntHex(entier-aM*16**M,-1,res)
	
	return res	
DicoFonctions["IntHex"]=IntHex.__doc__	

def HexInt(hexa):
	""" transforme un hexadecimal de longueur N en entier """
	res=""
	try:
		N=len(hexa)
	except:
		hexa=[hexa]
		N=len(hexa)
	for i in range(N):
		if N==1:
			if ord(hexa[i])<48+10:
				nb=ord(hexa[i])-48
			else:
				nb=ord(hexa[i])-87
			res=nb
		else:		
			nb=0		
			for j in range(N):
				nb=nb*16+HexInt(hexa[j])
			res=nb
	return res		
DicoFonctions["HexInt"]=HexInt.__doc__		
	
'''
def EstUnEntier(obj):
	""" Verifie si un objet est un entier(int)"""
	if isinstance(obj,int):
		return True
	else:
		return False
		
def EstUnReel(obj):
	""" Verifie si un objet est un reel(float)"""
	if isinstance(obj,float):
		return True
	else:
		return False		
		
def EstUnTuple():
	""" Verifie si un objet est un tableau de type tuple(tuple)"""
	if isinstance(obj,tuple):
		return True
	else:
		return False
'''
def EstUn(obj,typeuh,strict=True):
	""" Verifie si un objet est un (typeuh)"""
	if strict==True:
		if isinstance(obj,typeuh):
			return True
		else:
			return False
	else:
		if isinstance(obj,str):
			if chr(typeuh(obj))==obj:
				return True
			else:
				return False	
		else:
			return False		
		
def EstUnEntier(obj,strict=True):
	""" Verifie si un objet est un entier(int)"""
	return EstUn(obj,int,strict)
		
def EstUnReel(obj,strict=True):
	""" Verifie si un objet est un reel(float)"""
	return EstUn(obj,float,strict)
		
def EstUnTuple(obj,strict=True):
	""" Verifie si un objet est un tableau de type tuple(tuple)"""
	return EstUn(obj,tuple,strict)

def EstUnechaine(obj,strict=True):
	""" Verifie si un objet est une chaine de caractères(str)"""
	return EstUn(obj,str,strict)

def EstUnArray(obj,strict=True):
	""" Verifie si un objet est un tableau []"""
	return EstUn(obj,list,strict)




import csv
def DictToClefs(dico):
	return [clef for clef in dico.keys()]
def TabloDeDictToClefs(tablo):
	dico=dict()
	for tmp in tablo:
		dico.update(tmp)
	return DictToClefs(dico)
def ToCsv(tablo,fichier='/tmp/CXml.csv',*Clefs,ID=True):
	"""ToCsv(tablo,fichier='/tmp/CXml.csv',*Clefs) : nécessite tablo=[dico1,dico2...] avec dico[cle]=valeur\
	par exemple ToCsv(TabloDeDict,"/tmp/a.csv",TabloDeDictToClefs(TabloDeDict)]
	"""
	Champs=[]
	if ID==True:
		Champs=["id"]
	if len(Clefs)!=0:
		Champs=Champs+list(Clefs)[0]
	#print(Champs)
	
	with open(fichier, 'w', newline='') as csvfile:
		fieldnames = Champs
		writer = csv.DictWriter(csvfile, fieldnames=fieldnames,delimiter="#")
		writer.writeheader()
		for no,dico in enumerate(tablo):
			ID=dict()
			ID["id"]=str(no)			
			ID.update(dico)
			writer.writerow(ID)
		"""	
		writer.writerow({'first_name': 'Baked', 'last_name': 'Beans'})
		writer.writerow({'first_name': 'Lovely', 'last_name': 'Spam'})
		writer.writerow({'first_name': 'Wonderful', 'last_name': 'Spam'})
		"""
	#return res	













	
global main

if __name__ == "__main__":
	Dprint("Le programme lancé est "+sys.argv[0])
	print(HexsInt('1ab',1))
	print(_FonctionDuProgramme)
	print("version:"+_Version)

	print('= '*20)
	print('import CFonctions')
	for a in DicoFonctions:
		print('\nfrom CFonctions import '+a)
		print("  "+DicoFonctions[a])
	
	
	
	sys.exit()


