from __future__ import print_function
# -*- coding: utf-8 -*-
_FonctionDuProgramme="_FonctionDuProgramme"
print(_FonctionDuProgramme)

import re
##################### debug
import sys

_debug_Titres=True #_debug_Titres=False
_debug_all=True # 
_debug_all=False

if _debug_all==True:
	_debug_Titres=True

if _debug_Titres==True:
	_FichierLog='/tmp/'+sys.argv[0]+'.log'
	_Log=open(_FichierLog,'w')

def Tprint(*args, **kwargs):
	if _debug_Titres==True:
		print(*args, **kwargs)					
		print(*args,file=_Log)
def dprint(ligne):
	if _debug==True:
		print(ligne)
		print('--------------------------')
# # # # # # # # # # # # # # # # # # # debug

class br_CDICO(dict):
	  def __missing__(self, key):
		  return ""

class CProjetDePo(object):
	def __init__(self,_rep=''):
		self._repertoire=_rep




if _debug_Titres==True:
	_Log.close()
	
	
	
	
	
	
	
	
	
	
	
	
	

import bpy
from mathutils import *
from math import *
scene=bpy.data.scenes['Scene']


def SelectionneObjet(nom):
	for i in scene.objects:
		i.select=False
	scene.objects[nom].select=True
	scene.objects.active=scene.objects[nom]
	return scene.objects[nom]

def ListeObjetsName():
	return [obj.name for obj in scene.objects]	
	
def ListeObjets():
	return [obj for obj in scene.objects]		
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	


def QuelleDeformation(DeformationX,X,dist):
	#typeuh='moyenne'
	typeuh='lineaire'
	if typeuh=='lineaire':
		d=abs(DeformationX-X)/dist		
		return DeformationX + d*(X-DeformationX)
	if typeuh=='moyenne':
		return 0.5*(DeformationX+X)



def QuelleDeformation3D(DeformationR,PositionNormaleR,dist,distTransversal):
	typeuh='lineaire'
	if typeuh=='lineaire':
		DeformationX=DeformationR[0]
		X=PositionNormaleR[0]		
		d=abs(DeformationX-X)/dist
		
		DNormale=(PositionNormaleR[1]**2+PositionNormaleR[2]**2)*0.5
		DDeformation=(DeformationR[1]**2+DeformationR[2]**2)*0.5
		Dd=abs(DDeformation-DNormale)/distTransversal
		
		Res=PositionNormaleR*Dd*d
		Res[0]=DeformationX + d*(X-DeformationX)
		return Res# DeformationX + d*(X-DeformationX) , PositionNormaleR[1]+ (1-Dd) *(DeformationR[1]- PositionNormaleR[1]),  PositionNormaleR[2]+ Dd *(DeformationR[2]- PositionNormaleR[2]) ))
	
def QuelleDeformation3D2(Deformation,PositionNormale,dist):
	typeuh='lineaire'
	if typeuh=='lineaire':
		R=((PositionNormale[0]-Deformation[0])**2+PositionNormale[1]**2+PositionNormale[2]**2)*0.5	
		d=R/dist
		
		Res=Deformation + d*(PositionNormale-Deformation)
		return Res# Defo
		
def QuelleDeformation3D3(PositionNormale,Omega,K,t):#v3
	typeuh='spherique'
	if typeuh=='spherique':
		R=((PositionNormale[0])**2+PositionNormale[1]**2+PositionNormale[2]**2)*0.5	
		d=R/dist
		Deformation=0+0.01*cos(Omega*t-R*K)*(t> 0)
		Res=PositionNormale*(1+Deformation)
		return Res# Defo
ListeDesStables=[]
#dx=1 ; dy=dz=0.1 7 T=0.03 #CRessort.002
dx=1 
dy=dz=0.1 
T=0.03

dist=0.02

VitesseOnde=dist/2.0 #deplacement par frame
Omega=1
K=Omega/VitesseOnde



PositionNormale=[]
	
TailleCube=2*1+1
NbdeSpheres=TailleCube*TailleCube*TailleCube

def s

for k in range(TailleCube):
	for j in range(TailleCube):
		for i in range(TailleCube):
			no=TailleCube*TailleCube*k+TailleCube*j+i
			nom='Fleche.'+str(no).zfill(3)
			#print(nom)
			if nom not in ListeObjets():
				tmp=ListeObjets()
				scene.objects.active=scene.objects['Fleche']
				bpy.ops.object.duplicate_move(OBJECT_OT_duplicate={"linked":False, "mode":'TRANSLATION'}, TRANSFORM_OT_translate={"value":(1.33816, 0.205591, 0.483697), "constraint_axis":(False, False, False), "constraint_orientation":'GLOBAL', "mirror":False, "proportional":'DISABLED', "proportional_edit_falloff":'SMOOTH', "proportional_size":1, "snap":False, "snap_target":'CLOSEST', "snap_point":(0, 0, 0), "snap_align":False, "snap_normal":(0, 0, 0), "gpencil_strokes":False, "texture_space":False, "remove_on_cancel":False, "release_confirm":False})

				bpy.ops.mesh.primitive_uv_sphere_add(view_align=False, enter_editmode=False, location=(-0.295309, 0.556019, 0.0922348), layers=(True, False, False, False, False, False, False, False, False, False, False, False, False, False, False, False, False, False, False, False))
				
				for objn in ListeObjets():
					if objn not in tmp:
						scene.objects[objn].name=nom
			scene.objects[nom].location=0.03*Vector((i,j-(TailleCube-1)/2,k-(TailleCube-1)/2))
			scene.objects[nom].keyframe_insert("location",frame=0)
			scene.objects[nom].scale=0.01*Vector((1,1,1))
			PositionNormale.append(Vector((0,0,0)))

for k in range(TailleCube):
	for j in range(TailleCube):
		for i in range(TailleCube):
			no=TailleCube*TailleCube*k+TailleCube*j+i
			nom='Sphere.'+str(no).zfill(3)						
			PositionNormale[no]=Vector([scene.objects[nom].location[i] for i in range(3)])







for frameuh in range(1,30):
	print(frameuh)
	ADeformation=(frameuh-1)*VitesseOnde
	scene.objects["Deformation"].location=Vector((ADeformation,0,0))
	scene.objects["Deformation"].keyframe_insert("location",frame=frameuh)
	
	for k in range(TailleCube):
		for j in range(TailleCube):
			for i in range(TailleCube):
				no=TailleCube*TailleCube*k+TailleCube*j+i
				nom='Sphere.'+str(no).zfill(3)						
				
				'''
				X=PositionNormale[no][0]
				R=(PositionNormale[no][1]**2+PositionNormale[no][2]**2)*0.5
				if abs(X-Deformation[0]) < dist and abs(R) < distTransversal:
					#scene.objects[nom].location[0] = QuelleDeformation(Deformation[0],X,dist)
				'''	
				R=(PositionNormale[no][0]**2+PositionNormale[no][1]**2+PositionNormale[no][2]**2)*0.5	
				if abs(R-ADeformation) < dist:
					scene.objects[nom].location = QuelleDeformation3D3(PositionNormale[no],Omega,K,frameuh)
					scene.objects[nom].keyframe_insert("location",frame=frameuh)
					try:
						del ListeDesStables[ListeDesStables.index(no)]
					except:
						pass	
					
					#
				else:
					if no in ListeDesStables:
						#scene.objects[nom].location[0] = vector([PositionNormale[no][i] for i in range(3)])
						#scene.objects[nom].keyframe_insert("location",frame=frameuh)						
						
						pass
					else:
						scene.objects[nom].location = Vector([PositionNormale[no][i] for i in range(3)])
						scene.objects[nom].keyframe_insert("location",frame=frameuh)						
						ListeDesStables.append(no)
	#print(ListeDesStables)
			









